Panteltje xpvox-0.9.5 manual

xpvox is copyright (c) 2005-always Jan Panteltje and released under the GPL.

xpvox is a voice control program that monitors the soundcard output and controls

xpvox is a voice control program that monitors the soundcard output and controls
a radio transmitter via a pin on the serial port.
This way you can start transmission under voice control.

It can output the audio in 44100 samples / second mono 16 bits to stdout.
You can record everything in mp3 format like this:
xpvox -o | lame -r -s 44100 -m m -x - out.mp3

Or, if you do not want to record audio:
xpvox

You need:
xforms installed, and the forms.h header file.
libpthread, and libmath.

* xpvox currently needs to be run as root, because it does direct IO to the serial port. *

The RTS pin on the serial port is set to 1 if audio is detected.
Change defaults for /dev/dsp and /dev/cua0 in xpvox.h, then compile:
make
make install
make install.man

Make a directory where the settings are saved:
mkdir -p ~/.xpvox/setup

Note:
 When starting xpvox for the first time, the files that hold the settings are not found,
 and several warnings may pop up.
 Once you see the program, move all sliders, add some .wav sound file with add, and select that
 in file the browser.
 That should create the setup files and make the error messages go away the next time you start xpvox.
 When you do NOT want to use RTS (use xpvox only for voice controled recording), it can be run as non root
 by specifying the -i flag 'xpvox -i'. Then the serial port RTS will NOT be activated. 


Type:
xpvox -h for help
or
man xpvox


Three sliders are provided to adjust to your voice:
'threshold' sets the percentage of 100% audio needed that triggers the voice circuit.
'on mS' sets the time the sound needs to be prsent for the transmitter to turn on.
'off mS' sets the time the transmitter stays on after the last sound.

The 'Inhibit' button will set RTS low when pressed, and prevent it from going high.
Releasing this button sets RTS to the current transmit state.
No other functions are affected, so it can be used to test the player etc..

RTS indicator:
This indicator will be red when RTS is driven high (transmitter switched on).

Transmit button:
The big square button in the middle will activate RTS when pressed, if Inhibit button is not active.

The TXLOCK button will toggle transmit receive.

Audio player:
Supports .wav(uses play) and .mp3, .mp2, and .mpa(uses mpg123), output to /dev/dsp1 or what is selected
with the -p command line flag.

DSP devide input select button:
To select the dsp device that xpvox reads from, press the input button repreatedly.
This is the dsp device the microphone is connected to.

DSP device output selection button:
To select the dsp device that the audio player uses, press the button on the left that shows
the dsp device repeatedly.
A warning will pop up if you try to change dsp device while playing is in progress, in that case press
the stop button first.

To add an audio file to the list press the 'add' button.
Use the file selector to select a directory and file.

To delete a file from the list press the 'del' button, you will be asked for confirmation.

To play a file, left mouse click on its entry in the browser, so it is selected.
Press 'pla' button.

To stop playing a file press 'sto' button.
**Note: this will kill all programs using this dsp device!!!!

To select a file for 'roger beep' (lead out), right mouse select it, it will become red.
To select a file to be played immediatly if you pressed TRANSMIT (lead in), middle mouse click it,\
it will become purple.
If you use the same file for lead in and lead out, that entry will become green.
To enable lead in press the 'in' button;
To enable lead out press the 'out' button.


BEACON button:
When the BEACON button is pressed the selected sound is played at the interval set by the 'seconds' input
field.

Timed play button:
When this button is pressed, the file player will start at the time specified in the input field next to it.
The time format is hh:mm as a 24 hour clock.
By double clicking left mouse in the sound browser you can assign a sequence number to a sound item.
Assigning sequence number 0 (use CLEAR in the pop up question form) removes the item from the list.
Sequence playing always starts at 1.
Items are renumbered so removed numbers are taken again.
Playing stops when the last item has been played, or the timed play button is released.
The time play button is ORANGE when waiting for a time match, RED during playing, and YELLOW when playing has
finished.
The button will automatically release when all items are played.
When the timed play button is pressed, and transmit is not happening, the transmit button will show the
time to transmission.
At 5 minutes before the transmit time, 10 beeps, one per second, will be sounded from the PC speaker,
as an attention sign.
When timed play button is pressed and transmission is in progress, the transmit button will show the time
in transmission.


Daily button:
If this button is pressed, only one numbered entry from the list is played each day (timer match).
The field above the button marked 'next' shows the next entry to be played.
You can edit this value.
This feature allows you to program automatic transmissions at a fixed time, for several days ahead.

No path button:
When pressed the pathname to the soundfiles wuill not be displayed, this is intended to help
reading filenames in the available small window space.

Log button:
When pressed you can specify a log filename, the preferred extention is .log, the default
dir will be the home directory.
You can override startup logfilename by using the command line option '-l logfilename'.
Data is always appended to the logfile, and a new one is created if the requested file does not exists.
Only the times of changes to RTS are logged! this together with any played filename.

AGC button:
AGC (automatic gain correction) will _only_ work on the level meter and the -o output.
For example, if you have 2 sound cards you can use xpvox like this when playing via /dev/dsp0:
xpvox -o | sox -r 44100 -w -c 1 -s -t raw - -r 44100 -w -c 1 -s -t ossdsp /dev/dsp1
This will limit and kleep ouput constant via output on /dev/dsp1.
NOT via /dev/dsp0!!!!
Pressing the AGC button will activate the AGC.
On start up, the AGC system multiplies the output by a factor 1x.
When no signal exceeds -3dB (.7x max output) the multiplication factor will increase very fast (within a second) up until 50x,
until a signal of > 3dB is sensed.
When this happens the multiplication factor is adjusted downwards, so the output is exactly -3dB at that peak.
From this moment on the gain will increase very very slowly (over minutes) when there are no peaks higher then -3dB in the audio.
The result should be music or speech always at a peak level of -3dB not clipping, independent of the source recording,
almost ideal for digital audio.
When the AGC is in the fast startup mode the button will light up red, after that it will light up orange.
If you need the AGC function and have only _one_ soundcard, look for the program xpequ to play the audio:
 http://panteltje.com/panteltje/xpequ/index.html, also on ftp://sunsite.unc.edu/pub/linux/apps/audio/

xpq button:
Pressing the xpq button will use (and pop-up) xpequ as player for mpa, mp2, mp3, and wav format.
In case of mpa, mp2, and mp3 mpg123 is also called.
xpequ will be activated for ALSA hw:0,0 as output, and .
You can then use the AGC and equalizer in xpequ.
Do not use the xpvox AGC in this mode, the level indicator will then not show the right level.


When the program is re-started all settings are saved.


Transmitting speech and music with high dynamic range:
Since the dynamic range of the transmission channel is likely limited, we can use a compander.
In the old days there was a chip: Philips NE570.
These days we have the 'sox' program, it has a compand option.
I took the datasheet from the NE570, copied the curve to sox parameters:
-80,-40,-60,-30,-40,-20,0,0 (sox can only go to 0dB)
Then I took the CCIT recommendation from the NE570 application note, CCIT attack: 3+-2ms release 13.5+-9ms:
0.003,.013.5
Now I could make a compander program for wave files:
sox example.wav example_companded.wav compand 0.003,.013.5 -80,-40,-60,-30,-40,-20,0,0 1
Most of it will now be at the same level!
If you have 2 soundcards you could pipe the output of xpvox through this into the other dsp device,
and have your mike companded too!
If not then you can pre-process your waves or mp3 (make a wave with mpg123 -w xxx.wav xxx.mp3).

Player helper applications used:
For mp3, mp2 and mpa format mpg123 is used.
For wav format sox is called directly.
For all other formats mplayer is called.
When you play a movie mplayer should send the sound to the selected output device, and show a picture.


Command line option '-s'.
Normally xpvox outputs all audio to stdout if the '-o' command line option is specified.
When also the '-s' command line option is specified, only those parts of the sound where RTS was 1
are output.
You can encode to mp3 with lame, this will only record RTS on parts:
xpvox -o -s | lame -r -s 44100 -m m -x - out.mp3
To record all audio coming from the device:
xpvox -o | lame -r -s 44100 -m m -x - out.mp3


Files:
~/.xpvox/processlist.txt
~/.xpvox/sounds.dat
~/.xpvox/sounds.dat~
~/.xpvox/setup/on_milli_seconds
~/.xpvox/setup/off_milli_seconds
~/.xpvox/setup/threshold
~/.xpvox/setup/sound_dir
~/.xpvox/setup/selected_sound
~/.xpvox/setup/audio_play_device_number
~/.xpvox/setup/audio_settings
~/.xpvox/setup/log_filename
~/.xpvox/xpvox.xpm

end of text

